/*
 * LineBreak  ~  v.0.2  ~  NightOwl  ~  The main class of the Board element.
 */
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.FontFormatException;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.Toolkit;

import java.util.Timer;
import java.util.TimerTask;
import java.util.List;
import java.util.ArrayList;
import java.util.ListIterator;
import java.util.Iterator;
import java.util.Random;

import javax.swing.JPanel;
import javax.swing.JFrame;

import java.io.File;
import java.io.IOException;
import java.io.FileNotFoundException;

import java.lang.*;

public class Board extends JPanel{
    Timer timer;
    Paddle paddle;
    Level level;
    List<Ball> lball = new ArrayList<Ball>();
    List<Bonus> lbonus = new ArrayList<Bonus>();
    Ball new_ball;
    Iterator it,it2;
    Brick pbrick;   // pointer for iterator
    Bonus pbonus;   // pointer for iterator
    Ball pball;     // pointer for iterator

    int score = 0, mtimer = 0, lifes = Const.START_LIFES_AMOUNT;
    String message = "", levelname = "level1", scoresfilename = "highscores.txt", playername = "Player";
    Color mcolor = Color.black;
    List<Achievement> achievements = new ArrayList<Achievement>();

    boolean game = false;    // true = game;  false = menu
    boolean highscores = false, entername = false, enterlevelname = false, randomlevel = false, aboutwindow = false;
    int timerId;
    private Random rand = new Random(System.currentTimeMillis());

    Font title, menufont, guifont, tablefont;
    FontMetrics titlemetr, menumetr, guimetr, tablemetr;
    Color back_menu_color = new Color(255, 255, 255, 220);

    Menu menu;
    Scores scores;
    About about;

    public Board(){
        addKeyListener(new KAdapter());
        addMouseListener(new MAdapter());
        addMouseMotionListener(new MMAdapter());
        setFocusable(true);

        setDoubleBuffered(true);
        timer = new Timer();
        timer.scheduleAtFixedRate(new ScheduleTask(), 1000, 10);

        try{
            title = Font.createFont(Font.TRUETYPE_FONT, getClass().getResourceAsStream("Squared Display.ttf")).deriveFont(100.0f);
            titlemetr = getFontMetrics(title);
            menufont = Font.createFont(Font.TRUETYPE_FONT, getClass().getResourceAsStream("SVBasicManual.ttf")).deriveFont(40.0f);
            menumetr = getFontMetrics(menufont);
        } catch(NullPointerException e){
            System.out.print("Error =(\n");
        } catch(FileNotFoundException e){
            System.out.print("Error!\n");
            e.printStackTrace();
        } catch(FontFormatException e){
            System.out.print("Font format error!\n");
        } catch(IOException e){
            System.out.print("IO error!\n");
            try{
                title = Font.createFont(Font.TRUETYPE_FONT, new File("Squared Display.ttf")).deriveFont(100.0f);
                titlemetr = getFontMetrics(title);
                menufont = Font.createFont(Font.TRUETYPE_FONT, new File("SVBasicManual.ttf")).deriveFont(40.0f);
                menumetr = getFontMetrics(menufont);
            } catch(FileNotFoundException e2){
                System.out.print("Error!\n");
                e2.printStackTrace();
            } catch(FontFormatException e2){
                System.out.print("Font format error!\n");
            } catch(IOException e2){
                System.out.print("IO error!\n");
            }
        }
        guifont = menufont.deriveFont(30.0f);
        guimetr = getFontMetrics(guifont);
        tablefont = menufont.deriveFont(20.0f);
        tablemetr = getFontMetrics(tablefont);

        menu = new Menu(menufont, menumetr, Const.WIDTH/2, 210, 50);
        menu.addItem("< Play >"); menu.addSubItem(0, "< Random >"); menu.addSubItem(0, "< level1 >");
        menu.addItem("< Continue >");
        menu.addItem("< Scores >");
        menu.addItem("< About >");
        menu.addItem("< Quit >");

        scores = new Scores(scoresfilename);
        scores.setFonts(menufont, menumetr, guifont, guimetr);

        about = new About(menufont, menumetr, guifont, guimetr);

        achievements.add(new Achievement("No falls!", 200, true));
        achievements.add(new Achievement("Brownian motion!", 200));
        achievements.add(new Achievement("Saved the first ball!", 100, true));
        achievements.add(new Achievement("Giant ball!", 15));
        achievements.add(new Achievement("Giant paddle!", 15));
        achievements.add(new Achievement("Escape velocity!", 30));

    }

    public void addNotify() {
        super.addNotify();
        initGame();
    }

    public void initGame(){
        paddle = new Paddle(Const.WIDTH/2, Const.HEIGHT-80, Const.PADDLE_WIDTH, 10, Color.black);

        lball.add(new Ball(paddle.getX(),
                paddle.getY()-(Const.BALL_RADIUS+paddle.getHeight()/2), Const.START_BALL_ANGLE,
                Const.BALL_RADIUS, Color.red));
        lball.get(0).setPaddle(paddle);
        lball.get(0).setFixed(true);

        level = new Level(levelname+".txt");
    }
    public void resetGame() {
        new_ball = lball.get(0);
        lball.clear();
        new_ball.resetState();
        new_ball.setFixed(true);
        lball.add(new_ball);
        paddle.resetState();
        lifes = Const.START_LIFES_AMOUNT;
        score = 0;
        //timer.cansel();
    }
    public void gameQuit(){
        scores.saveScores(scoresfilename);
        JFrame.getFrames()[0].dispose();
        System.exit(1);
    }

    public void addMessage(String text, int time, Color color){
        message = text;
        mtimer = time;
        mcolor = color;
    }

    public void paint(Graphics g){
        super.paint(g);

        Graphics2D g2 = (Graphics2D) g;
        RenderingHints rh = new RenderingHints(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        rh.put(RenderingHints.KEY_RENDERING,
                RenderingHints.VALUE_RENDER_QUALITY);
        g2.setRenderingHints(rh);

        paddle.draw(g);
        level.draw(g);
        it = lbonus.iterator();
        while(it.hasNext()){
            pbonus = (Bonus)it.next();
            pbonus.draw(g2);
        }
        it = lball.iterator();
        while(it.hasNext()){
            pball = (Ball)it.next();
            pball.draw(g2);
        }
        // gui & menu
        if(game){
            g.setColor(Color.black);
            g.setFont(guifont);
            for(int i=0; i<lifes; i++) g.drawString("@", 24+i*20, Const.HEIGHT-45);
            g.drawString(""+score, Const.WIDTH-guimetr.stringWidth(""+score)-30, Const.HEIGHT-40);
        }
        else{
            g.setColor(back_menu_color);
            g.fillRect(8, 10, Const.WIDTH-20, Const.HEIGHT-50);
            if(highscores){
                scores.draw(g);
            }
            else if(aboutwindow){
                about.draw(g);
            }
            else if(entername){
                g.setFont(guifont);
                g.setColor(Color.black);
                g.drawString("Enter your name:", Const.WIDTH/2-150, Const.HEIGHT/2-40);
                if(System.currentTimeMillis()%800<400)
                    g.drawString("< "+playername+"|>",
                            Const.WIDTH/2-guimetr.stringWidth(playername)/2-20, Const.HEIGHT/2);
                else
                    g.drawString("< "+playername+" >",
                            Const.WIDTH/2-guimetr.stringWidth(playername)/2-20, Const.HEIGHT/2);
            }
            else{
                g.setFont(title);
                g.setColor(Color.black);
                g.drawString("LineBreak", Const.WIDTH/2-titlemetr.stringWidth("LineBreak")/2, 120);
                menu.draw(g);
            }
        }
        // draw message
        g.setFont(guifont);
        g.setColor(mcolor);
        g.drawString(message, Const.WIDTH/2-guimetr.stringWidth(message)/2, Const.HEIGHT-40);
        //
        Toolkit.getDefaultToolkit().sync();
        g.dispose();
    }

    private class KAdapter extends KeyAdapter{
        @Override
        public void keyReleased(KeyEvent e) {
        }
        @Override
        public void keyPressed(KeyEvent e) {
            switch(e.getKeyCode()){
                case KeyEvent.VK_ESCAPE:
                    if(game){ game = false; }
                    else{
                        if(highscores) highscores = false;
                        else if(aboutwindow) aboutwindow = false;
                        else if(entername){ entername = false; resetGame(); }
                        else{
                            if(menu.isExpand(0)) menu.setExpand(0, false);
                            else gameQuit();
                        }
                    }
                    break;
                case KeyEvent.VK_ENTER:
                    if(enterlevelname){
                        if(levelname.length()>0){
                            menu.setSubname(0, 1, "< "+levelname+" >");
                            enterlevelname = false;
                        }
                        else addMessage("The name can not be empty!", Const.MESSAGE_TIME, Color.red);
                    }
                    else if(entername){
                        if(playername.length()>0){
                            entername = false;
                            highscores = true;
                            if(randomlevel){ scores.addItem("Random", playername, score); }
                            else scores.addItem(levelname, playername, score);
                            randomlevel = false;
                            resetGame();
                        }
                        else addMessage("The name can not be empty!", Const.MESSAGE_TIME, Color.red);
                    }
                    break;
                case KeyEvent.VK_BACK_SPACE:
                    if(enterlevelname){
                        if(levelname.length()>0){ levelname = levelname.substring(0,levelname.length()-1); }
                    }
                    else if(entername){
                        if(playername.length()>0){ playername = playername.substring(0,playername.length()-1); }
                    }
                    break;
                default:
                    if(e.getKeyChar()>='0' && e.getKeyChar()<='z'){
                        if(enterlevelname){
                            if(levelname.length()<10){ levelname+=e.getKeyChar(); }
                        }
                        else if(entername){
                            if(playername.length()<15){ playername+=e.getKeyChar(); }
                        }
                    }
            }
        }
    }

    private void MouseClick(MouseEvent e){
        if(game){
            it = lball.iterator();
            while(it.hasNext()){
                pball = (Ball)it.next();
                if(pball.isFixed()) pball.setFixed(false);
            }
        }
        else{
            if(highscores){
                scores.mouseClicked(e);
            }
            else{
                menu.mouseClicked(e);
                if(e.getButton() == MouseEvent.BUTTON1){
                    switch(menu.getSelected()){
                        case 0:
                            if(!menu.isExpand(0)){
                                menu.setExpand(0, true);
                            }
                            break;
                        case 1: game = true; break;
                        case 2: highscores = true; break;
                        case 3: aboutwindow = true; break;
                        case 4: gameQuit(); break;
                    }
                    switch(menu.getSubSelected(0)){
                        case 0:                       // random game
                            level.generateLevel();
                            resetGame();
                            game = true;
                            randomlevel = true;
                            break;
                        case 1:                       // level from file
                            if(level.loadLevel(levelname+".txt")){
                                randomlevel = false;
                                resetGame();
                                game = true;
                            }
                            else{
                                addMessage("Wrong name!", Const.MESSAGE_TIME, Color.red);
                            }
                            break;
                    }
                }
                else if(e.getButton() == MouseEvent.BUTTON3){
                    switch(menu.getSubSelected(0)){
                        case 1:
                            enterlevelname = !enterlevelname;
                            if(!enterlevelname) menu.setSubname(0, 1, "< "+levelname+" >");
                            break;
                    }
                }
            }
        }
    }

    private class MAdapter extends MouseAdapter{
        @Override
        public void mouseClicked(MouseEvent e) {
            //MouseClick(e);
        }

        @Override
        public void mousePressed(MouseEvent e) {
            if(game){
                it = lball.iterator();
                while(it.hasNext()){
                    pball = (Ball)it.next();
                    if(pball.isFixed()) pball.setFixed(false);
                }
            }
        }

        @Override
        public void mouseReleased(MouseEvent e) {
            MouseClick(e);
        }

        @Override
        public void mouseEntered(MouseEvent e) {
        }

        @Override
        public void mouseExited(MouseEvent e) {
        }
    }
    private class MMAdapter extends MouseMotionAdapter{
        @Override
        public void mouseMoved(MouseEvent e){
            if(game) paddle.mouseMoved(e);
            else
                if(highscores) scores.mouseMoved(e);
                else menu.mouseMoved(e);
        }
        @Override
        public void mouseDragged(MouseEvent e){
            mouseMoved(e);
        }
    }
    class ScheduleTask extends TimerTask{
        public void run(){
            if(game){
                // balls movement
                for(ListIterator<Ball> i = lball.listIterator(); i.hasNext();){
                    pball = (Ball)i.next();
                    pball.move();
                    if(pball.getY()>Const.HEIGHT){
                        if(lball.size()>1){
                            i.remove();
                            // achievement
                            if(lball.indexOf(pball) == 0){ achievements.get(2).setAvailable(false); }
                        }
                        else{
                            pball.resetState();
                            pball.setFixed(true);
                            paddle.resetState();
                            if(lifes>0){
                                lifes--;
                                addMessage("-50 points", Const.MESSAGE_TIME, Color.red);
                                score-=50;
                                if(score<0) score = 0;
                                // achievement
                                achievements.get(0).setAvailable(false);
                            }
                            else{
                                game = false;
                                highscores = false;
                                entername = true;
                                if(randomlevel) scores.setCurrent("Random");
                                else scores.setCurrent(levelname);
                            }
                        }
                    }
                }
                // bonuses movement
                for(ListIterator<Bonus> i = lbonus.listIterator(); i.hasNext();){
                    pbonus = (Bonus)i.next();
                    pbonus.move();
                    if(pbonus.getY()>Const.HEIGHT){ i.remove(); }
                }
                // collisions
                checkCollision();
            }
            else if(!highscores){
                if(enterlevelname){
                    if(System.currentTimeMillis()%800<400) menu.setSubname(0, 1, "< "+levelname+"|>");
                    else menu.setSubname(0, 1, "< "+levelname+" >");
                }
            }
            // message timer update
            if(mtimer>0){
                mtimer--;
                if(mtimer == 0) message = "";
            }
            // paint all
            repaint();
        }
    }

    public void checkCollision(){
        it = lball.iterator();
        while(it.hasNext()){
            pball = (Ball)it.next();
            if(pball.getX()<pball.getRadius()) pball.changeDir(3);
            if(pball.getX()>Const.WIDTH-pball.getRadius()) pball.changeDir(1);
            if(pball.getY()<pball.getRadius()) pball.changeDir(0);
            if(pball.getRect().intersects(paddle.getRect())){
                if(pball.getX() < paddle.getRect().x) pball.changeDir(1);
                else if(pball.getX()>paddle.getRect().getMaxX()) pball.changeDir(3);
                if(pball.getY()+pball.getRadius()<paddle.getY()+2)
                    pball.changeDir(2,pball.getX()-paddle.getX());
            }
        }
        // level collisions
        it = level.getMap().iterator();
        while(it.hasNext()){
            pbrick = (Brick)it.next();
            if(!pbrick.isDestroyed()){
                it2 = lball.iterator();
                while(it2.hasNext()){
                    pball = (Ball)it2.next();
                    if(pball.getRect().intersects(pbrick.getRect())){
                        if(pball.getX()<pbrick.getRect().x) pball.changeDir(1);
                        else if(pball.getX()>pbrick.getRect().getMaxX()) pball.changeDir(3);
                        if(pball.getY()<pbrick.getRect().y) pball.changeDir(2);
                        else if(pball.getY()>pbrick.getRect().getMaxY()) pball.changeDir(0);
                        pbrick.hit();
                        if(pbrick.isDestroyed()){
                            if(rand.nextBoolean())
                                lbonus.add(new Bonus(pbrick.getX(), pbrick.getY(), 25, rand.nextInt(7)));
                        }
                        score++;
                        // check if win
                        if(level.isClear()){
                            game = false;
                            highscores = false;
                            entername = true;
                            if(randomlevel) scores.setCurrent("Random");
                            else scores.setCurrent(levelname);
                        }
                    }
                }
            }
        }
        // grab bonuses
        for(ListIterator<Bonus> i = lbonus.listIterator(); i.hasNext();){
            pbonus = (Bonus)i.next();
            if(pbonus.getRect().intersects(paddle.getRect())){
                switch (pbonus.getType()){
                    case 0:
                        addMessage("Speed +1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Ball speed up!\n");
                        it = lball.iterator();
                        while(it.hasNext()){
                            pball = (Ball)it.next();
                            pball.setSpeed(pball.getSpeed()+Const.BALL_SPEED_BONUS);
                        }
                        // achievement
                        if(lball.get(0).getSpeed()+Const.BALL_SPEED_BONUS >= Const.BALL_MAX_SPEED){
                            addMessage("Escape velocity!", Const.MESSAGE_TIME, Color.green.darker());
                            achievements.get(5).setAvailable(true);
                        }
                        break;
                    case 1:
                        addMessage("Speed -1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Ball speed down!\n");
                        it = lball.iterator();
                        while(it.hasNext()){
                            pball = (Ball)it.next();
                            pball.setSpeed(pball.getSpeed()-Const.BALL_SPEED_BONUS);
                        }
                        break;
                    case 2:
                        addMessage("Width +1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Paddle++!\n");
                        paddle.setWidth(paddle.getWidth() + Const.PADDLE_WIDTH_BONUS);
                        // achievement
                        if(paddle.getWidth()+Const.PADDLE_WIDTH_BONUS >= Const.PADDLE_MAX_WIDTH){
                            addMessage("Giant paddle!", Const.MESSAGE_TIME, Color.green.darker());
                            achievements.get(4).setAvailable(true);
                        }
                        break;
                    case 3:
                        addMessage("Width -1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Paddle--!\n");
                        paddle.setWidth(paddle.getWidth()-Const.PADDLE_WIDTH_BONUS); break;
                    case 4:
                        System.out.print("+ 2 balls!\n");
                        addMessage("+2 balls!", Const.MESSAGE_TIME, Color.darkGray);
                        new_ball = new Ball(lball.get(0).getX(), lball.get(0).getY(),
                                lball.get(0).getAngle()+60, lball.get(0).getRadius(), Color.red.darker());
                        new_ball.setFixed(false); new_ball.setPaddle(paddle);
                        new_ball.setSpeed(lball.get(0).getSpeed());
                        lball.add(new_ball);
                        new_ball = new Ball(lball.get(0).getX(), lball.get(0).getY(),
                                lball.get(0).getAngle()+120, lball.get(0).getRadius(), Color.red.darker());
                        new_ball.setFixed(false); new_ball.setPaddle(paddle);
                        new_ball.setSpeed(lball.get(0).getSpeed());
                        lball.add(new_ball);
                        // achievement
                        if(lball.size() == Const.ACHIEVE_BALLS){
                            addMessage("Brownian motion!", Const.MESSAGE_TIME, Color.green.darker());
                            achievements.get(1).setAvailable(true);
                        }
                        break;
                    case 5:
                        addMessage("Size +1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Ball++!\n");
                        it = lball.iterator();
                        while(it.hasNext()){
                            pball = (Ball)it.next();
                            pball.setRadius(pball.getRadius()+Const.BALL_RADIUS_BONUS);
                        }
                        // achievement
                        if(lball.get(0).getRadius()+Const.BALL_RADIUS_BONUS >= Const.BALL_MAX_RADIUS){
                            addMessage("Giant ball!", Const.MESSAGE_TIME, Color.green.darker());
                            achievements.get(3).setAvailable(true);
                        }
                        break;
                    case 6:
                        addMessage("Size -1", Const.MESSAGE_TIME, Color.darkGray);
                        System.out.print("Ball--!\n");
                        it = lball.iterator();
                        while(it.hasNext()){
                            pball = (Ball)it.next();
                            pball.setRadius(pball.getRadius()-Const.BALL_RADIUS_BONUS);
                        }
                        break;
                }
                score+=2;
                i.remove();
            }
        }
    }
}
