/*
 * LineBreak  ~  v.0.2  ~  NightOwl  ~  Bonus object.
 */
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.Graphics2D;

public class Bonus extends Primitive{
    private Triangle shape;
    protected int size, type;

    public Bonus(int x, int y, int size, int type){
        setSize(size);
        setType(type);
        changeColor();
        shape = new Triangle(x, y, size);
        setPosition(x, y);
    }
    // get
    public int getSize(){ return size; }
    public int getType(){ return type; }
    public Rectangle getRect(){
        return new Rectangle(getX()-size/2, getY()-size/2, size, size);
    }
    // set
    @Override
    public void setPosition(int x, int y){
        super.setPosition(x, y);
        shape.setPosition(x, y);
    }
    public void setSize(int size){
        this.size = size;
    }
    public void setType(int type){
        this.type = type;
    }
    //other
    public void changeColor(){
        switch(this.type){
            case 0: setColor(new Color(118, 223, 54, 182)); break;    // ball speed up
            case 1: setColor(new Color(255, 86, 81, 182)); break;     // ball speed down
            case 2: setColor(new Color(7, 0, 95, 182)); break;        // paddle width increase
            case 3: setColor(new Color(255, 224, 0, 182)); break;     // paddle width decrease
            case 4: setColor(new Color(106, 173, 255, 182)); break;   // add 2 balls
            case 5: setColor(new Color(181, 89, 255, 182)); break;    // ball size increase
            case 6: setColor(new Color(255, 58, 134, 182)); break;    // ball size decrease
        }
    }
    public void move(){
        setPosition(getX(), getY() + Const.BONUS_SPEED);
        shape.setAngle(shape.getAngle()+2);
    }
    public void draw(Graphics2D g){
        shape.draw(g, getColor(), true);
        shape.draw(g, Color.black, false);
    }
}
