/*
 * LineBreak  ~  v.0.2  ~  NightOwl  ~  Bricks description.
 */
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class Brick extends Primitive{
    private int width, height, level;
    private boolean destroyed;

    public Brick(int x, int y, int width, int height, int level){
        setPosition(x, y);
        setLevel(level);
        changeColor();
        setSize(width, height);
        setDestroyed(false);
    }
    // get
    public int getWidth(){ return width; }
    public int getHeight(){ return height; }
    public boolean isDestroyed(){ return destroyed; }
    public Rectangle getRect(){
        return new Rectangle(getX()-width/2, getY()-height/2, width, height);
    }
    // set
    public void setSize(int width, int height){
        this.width = width;
        this.height = height;
    }
    public void setDestroyed(boolean destroyed){
        this.destroyed = destroyed;
    }
    public void setLevel(int level){
        this.level = level;
    }
    // other
    public void changeColor(){
        switch(this.level){
            /*case 1: setColor(new Color(-790090)); break;
            case 2: setColor(new Color(-12477)); break;
            case 3: setColor(new Color(-39110)); break;
            case 4: setColor(new Color(-42400)); break;
            case 5: setColor(new Color(-4493825)); break;
            case 6: setColor(new Color(-9283073)); break;
            case 7: setColor(new Color(-14804408)); break;*/
            case 1: setColor(new Color(-836053)); break;
            case 2: setColor(new Color(-19926)); break;
            case 3: setColor(new Color(-4820)); break;
            case 4: setColor(new Color(-6760937)); break;
            case 5: setColor(new Color(-9183758)); break;
            case 6: setColor(new Color(-10525953)); break;
            case 7: setColor(new Color(-5097240)); break;
        }
    }
    public void draw(Graphics g){
        if(!destroyed){
            g.setColor(getColor());
            g.fillRect(getX() - width / 2, getY() - height / 2, width, height);
            g.setColor(Color.darkGray);
            g.drawRect(getX() - width / 2, getY() - height / 2, width, height);
            g.setColor(new Color(255, 255, 255, 34));
            g.fillRect(getX() - width / 2 + 5, getY() - height / 2 + 5, width - 9, height - 9);
        }
    }
    public void hit(){
        level--;
        changeColor();
        if(level<1){
            destroyed = true;
        }
    }
}