/*
 * LineBreak  ~  v.0.2  ~  NightOwl  ~  Paddle code.
 */
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.Graphics;
import java.awt.event.MouseEvent;

public class Paddle extends Primitive{
    private int width, height, startx, starty;

    public Paddle(int x, int y, int width, int height, Color color){
        startx = x; starty = y;
        setPosition(x, y);
        setColor(color);
        setSize(width, height);
    }
    // get
    public int getWidth(){ return width; }
    public int getHeight(){ return height; }
    public Rectangle getRect(){
        return new Rectangle(getX()-width/2, getY()-height/2, width, height);
    }
    // set
    public void setSize(int width, int height){
        this.width = width;
        this.height = height;
    }
    public void setWidth(int width){
        if((width >= Const.PADDLE_MIN_WIDTH) && (width <= Const.PADDLE_MAX_WIDTH)) this.width = width;
    }
    public void setX(int x){
        setPosition(x,getY());
    }
    // other
    public void resetState(){
        setWidth(Const.PADDLE_WIDTH);
    }
    public void draw(Graphics g){
        if(width > Const.PADDLE_WIDTH) g.setColor(Color.darkGray);
        else g.setColor(getColor());
        g.fillRect(getX() - width / 2, getY() - height / 2, width, height);
        if(width > Const.PADDLE_WIDTH){
            g.setColor(getColor());
            g.fillRect(getX() - Const.PADDLE_WIDTH / 2, getY() - height / 2, Const.PADDLE_WIDTH, height);
        }
    }
    public void mouseMoved(MouseEvent e){
        setX(e.getX());
    }
}
